Newer
Older
#!/bin/sh
#------------------------------------------------------------------------------
# ========= |
# \\ / F ield | OpenFOAM: The Open Source CFD Toolbox
# \\ / O peration |
# \\ / A nd | Copyright (C) 2011-2016 OpenFOAM Foundation
Mark Olesen
committed
# \\/ M anipulation | Copyright (C) 2016 OpenCFD Ltd.
#-------------------------------------------------------------------------------
# License
# This file is part of OpenFOAM.
#
# OpenFOAM is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License
# along with OpenFOAM. If not, see <http://www.gnu.org/licenses/>.
#
# Script
# paraFoam
#
# Description
# Start paraview with the OpenFOAM libraries and reader modules.
# Combining -block or -builtin options with -region option yields
# undefined behaviour
#------------------------------------------------------------------------------
usage() {
while [ "$#" -ge 1 ]; do echo "$1"; shift; done
cat<<USAGE
Usage: ${0##*/} [OPTION] [--] [PARAVIEW_OPTION]
-block use blockMesh reader (uses .blockMesh extension)
-case <dir> specify alternative case directory, default is the cwd
-region <name> specify alternative mesh region
-touch create the file (eg, .blockMesh, .OpenFOAM, .foam, ...)
-touch-all | -touchAll
create .blockMesh, .foam, .OpenFOAM files (for all regions)
-touch-proc same as '-touch' but for each processor
-vtk | -builtin use VTK builtin OpenFOAM reader (uses .foam extension)
-help print the usage
--help paraview help
Start paraview with the OpenFOAM libraries and reader modules.
Note that paraview options begin with double dashes.
Mark Olesen
committed
paraview=$(command -v paraview)
# Report error and exit
die()
{
exec 1>&2
echo
echo "Error encountered:"
while [ "$#" -ge 1 ]; do echo " $1"; shift; done
echo
echo "See '${0##*/} -help' for usage"
echo
exit 1
}
#-------------------------------------------------------------------------------
# Do a nice exit to give paraview an opportunity to clean up
unset FOAM_ABORT
# Hack: change all locale to 'C' i.e. using '.' for decimal point. This is
# only needed temporarily until paraview is locale aware. (git version is
# already 2010-07)
export LC_ALL=C
Mark Olesen
committed
# Reader extension and plugin
extension=OpenFOAM
Mark Olesen
committed
plugin=PVFoamReader
# Parse options
unset regionName optTouch
extension=blockMesh
Mark Olesen
committed
plugin=PVblockMeshReader
shift
;;
-vtk | -built*)
extension=foam
Mark Olesen
committed
unset plugin
[ "$#" -ge 2 ] || die "'$1' option requires an argument"
cd "$2" 2>/dev/null || die "directory does not exist: '$2'"
shift 2
;;
-region)
[ "$#" -ge 2 ] || die "'$1' option requires an argument"
regionName=$2
shift 2
;;
-touch)
optTouch=true
Mark Olesen
committed
unset plugin
-touch-all | -touchAll)
optTouch=all
Mark Olesen
committed
unset plugin
shift
;;
-touch-proc*)
optTouch=processor
unset plugin
shift
;;
break # Stop here, treat balance as paraview options
--help) # Emit paraview help directly
exec paraview "$@"
echo "Error: could not exec paraview" 1>&2
exit 1 # This should not have happened
;;
break # Stop here, treat this and balance as paraview options
die "unknown option/argument: '$1'"
Mark Olesen
committed
# If a reader module is needed, check that it exists
[ -z "$plugin" -o -f $PV_PLUGIN_PATH/lib${plugin}_SM.so ] || {
cat<< BUILDREADER 1>&2
Mark Olesen
committed
ERROR: ParaView reader module library ($plugin) does not exist
Please build the reader module before continuing:
Mark Olesen
committed
cd \$WM_PROJECT_DIR/applications/utilities/postProcessing/graphics/PVReaders
Mark Olesen
committed
./Allwclean
./Allwmake
Mark Olesen
committed
# Fallback to native reader, if possible
if [ "$extension" = OpenFOAM ]
then
extension=foam
echo "Using the native VTK/OpenFOAM reader instead" 1>&2
else
exit 1
fi
}
# Check for --data=... argument
hasDataArg()
{
hasData=false
while [ "$#" -gt 0 ]
do
case "$1" in
(--data=*)
hasData=true
break
;;
esac
shift
done
}
hasDataArg $@
# Get a sensible caseName from the directory name
caseFile="$caseName.$extension"
fvControls="system"
[ -d constant/$regionName ] || {
Mark Olesen
committed
echo "FATAL ERROR: Region $regionName does not exist" 1>&2
}
caseFile="$caseName{$regionName}.$extension"
fvControls="$fvControls/$regionName"
case "${optTouch:-false}" in
all)
extension=OpenFOAM
if [ -f system/blockMeshDict -o -f constant/polyMesh/blockMeshDict ]
then
touch "$caseName.blockMesh"
Mark Olesen
committed
echo "Created '$caseName.blockMesh'" 1>&2
touch "$caseName.$extension" "$caseName.foam"
echo "Created '$caseName.$extension' '$caseName.foam'" 1>&2
# Discover probable regions
for region in constant/*
do
if [ -d $region -a -d $region/polyMesh ]
then
regionName=${region##*/}
touch "$caseName{$regionName}.$extension"
Mark Olesen
committed
echo "Created '$caseName{$regionName}.$extension'" 1>&2
fi
done
exit 0
;;
processor)
for i in processor*
do
(
cd $i 2> /dev/null && touch "${caseFile%.*}#${i#processor}.$extension"
)
done
echo "Created '$caseFile' for processor directories" 1>&2
exit 0
;;
touch "$caseFile"
Mark Olesen
committed
echo "Created '$caseFile'" 1>&2
248
249
250
251
252
253
254
255
256
257
258
259
260
261
262
263
264
265
266
267
268
269
270
271
272
273
274
275
276
277
278
279
280
281
282
283
# Check existence of some essential OpenFOAM files.
# If caseName appears to be a processor directory, check parent as fallback
hasFiles() {
local warn="Cannot locate OpenFOAM-format case files:"
local parent
case "$caseName" in (processor*) parent="../" ;; esac
for file
do
if [ -s "$file" ]
then
continue
elif [ -n "$parent" -a -s "$parent$file" ]
then
continue
else
# Not found
[ -n "$warn" ] && echo "$warn" 1>&2
unset warn
if [ -n "$parent" ]
then
echo " $file, or $parent$file" 1>&2
else
echo " $file" 1>&2
fi
fi
done
if [ -n "$warn" ]
then
return 0 # No warnings were triggered
else
echo 1>&2 # Emit an additional separator line
return 1
fi
}
if [ "${hasData:-false}" = true ]
then
# Has --data=.., send directly to paraview
exec paraview "$@"
echo "Error: could not exec paraview" 1>&2
exit 1 # This should not have happened
else
# Check existence of essential files
warn=false
case $extension in
blockMesh)
Mark Olesen
committed
blockMeshDict=system/blockMeshDict
if [ -f constant/polyMesh/blockMeshDict ]
then
Mark Olesen
committed
blockMeshDict=constant/polyMesh/blockMeshDict
hasFiles system/controlDict $blockMeshDict || warn=true
Mark Olesen
committed
OpenFOAM)
hasFiles \
system/controlDict \
$fvControls/fvSchemes \
$fvControls/fvSolution || warn=true
[ "${warn:-false}" = false ] || {
echo -n "Would you like to open paraview anyway <Y|n>: "
case "${open:-y}" in ([Yy]*) paraview ;; esac
# Only create/remove caseFile if it didn't already exist
[ -e $caseFile ] || {
trap "rm -f $caseFile 2>/dev/null; exit 0" EXIT TERM INT
touch "$caseFile"
Mark Olesen
committed
echo "Created temporary '$caseFile'" 1>&2
# For now filter out any ld.so errors. Caused by non-system compiler?
paraview --data="$caseFile" "$@" 2>&1 \
| fgrep -v 'Inconsistency detected by ld.so'
#------------------------------------------------------------------------------